//+------------------------------------------------------------------+
//|                                             Oma macd 4 color mtf |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property  indicator_separate_window
#property  indicator_buffers 5
#property  indicator_color1  LimeGreen
#property  indicator_color2  DarkGreen
#property  indicator_color3  Red
#property  indicator_color4  Maroon
#property  indicator_color5  DimGray
#property indicator_width1   2
#property indicator_width2   2
#property indicator_width3   2
#property indicator_width4   2
#property indicator_width5   2
#property indicator_level1   0
#property indicator_levelcolor Gold
#property indicator_levelstyle STYLE_DOT

//
//
//
//
//

extern string TimeFrame         = "Current time frame";
extern int    FastOmaLength     = 25;
extern double FastOmaSpeed      = 8.0;
extern int    FastOmaPrice      = PRICE_CLOSE;
extern bool   FastOmaAdaptive   = true;
extern int    SlowOmaLength     = 100;
extern double SlowOmaSpeed      = 8.0;
extern int    SlowOmaPrice      = PRICE_CLOSE;
extern bool   SlowOmaAdaptive   = true;
extern bool   Interpolate       = true;
extern bool   InterpolateColors = false;

double macd[];
double green_buffer[];
double dkgreen_buffer[];
double red_buffer[];
double maroon_buffer[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,green_buffer);     SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(1,dkgreen_buffer);   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(2,red_buffer);       SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(3,maroon_buffer);    SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(4,macd);
   
      FastOmaLength = MathMax(FastOmaLength,   1);
      FastOmaSpeed  = MathMax(FastOmaSpeed ,-1.5);
      SlowOmaLength = MathMax(SlowOmaLength,   1);
      SlowOmaSpeed  = MathMax(SlowOmaSpeed ,-1.5);
   
   indicatorFileName = WindowExpertName();
   calculateValue    = (TimeFrame=="CalculateValue"); if (calculateValue) return(0);
   returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   
   IndicatorShortName(timeFrameToString(timeFrame)+" omacd ("+FastOmaLength+","+SlowOmaLength+")");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
  {
   
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMin(Bars-counted_bars,Bars-1);
         if (returnBars)  { green_buffer[0] = limit+1; return(0); }
   
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      for(i=limit; i>=0; i--)
      {
         macd[i] = iSmooth(iMA(NULL,0,1,0,MODE_SMA,FastOmaPrice,i),FastOmaLength,FastOmaSpeed,FastOmaAdaptive,i,0)-
                   iSmooth(iMA(NULL,0,1,0,MODE_SMA,SlowOmaPrice,i),SlowOmaLength,SlowOmaSpeed,SlowOmaAdaptive,i,7);
         dkgreen_buffer[i] = 0;
         green_buffer[i]   = 0;
         red_buffer[i]     = 0;
         maroon_buffer[i]  = 0;
        
         if(macd[i] > 0) 
               if (macd[i]>macd[i+1])
                     green_buffer[i]   = macd[i];
               else  dkgreen_buffer[i] = macd[i];
         if(macd[i] < 0) 
               if (macd[i]<macd[i+1])
                     red_buffer[i]    = macd[i];
               else  maroon_buffer[i] = macd[i];
      }
      return(0);
   }
  
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
     int y = iBarShift(NULL,timeFrame,Time[i]);
  
      macd[i]           = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",FastOmaLength,FastOmaSpeed,
                          FastOmaPrice,FastOmaAdaptive,SlowOmaLength,SlowOmaSpeed,SlowOmaPrice,SlowOmaAdaptive,4,y);
      green_buffer[i]   = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",FastOmaLength,FastOmaSpeed,
                          FastOmaPrice,FastOmaAdaptive,SlowOmaLength,SlowOmaSpeed,SlowOmaPrice,SlowOmaAdaptive,0,y);
      dkgreen_buffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",FastOmaLength,FastOmaSpeed,
                          FastOmaPrice,FastOmaAdaptive,SlowOmaLength,SlowOmaSpeed,SlowOmaPrice,SlowOmaAdaptive,1,y);
      red_buffer[i]     = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",FastOmaLength,FastOmaSpeed,
                          FastOmaPrice,FastOmaAdaptive,SlowOmaLength,SlowOmaSpeed,SlowOmaPrice,SlowOmaAdaptive,2,y);
      maroon_buffer[i]  = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",FastOmaLength,FastOmaSpeed,
                          FastOmaPrice,FastOmaAdaptive,SlowOmaLength,SlowOmaSpeed,SlowOmaPrice,SlowOmaAdaptive,3,y);

      //
      //
      //
      //
      //
      
      if (timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
      if (!Interpolate) continue;

     //
     //
     //
     //
     //

     datetime time = iTime(NULL,timeFrame,y);
         for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
         for(int k = 1; k < n; k++)
         {
            macd[i+k]           = macd[i]          + (macd[i+n]          - macd[i]          )*k/n;
            if (InterpolateColors)
            {
               green_buffer[i+k]   = green_buffer[i]  + (green_buffer[i+n]  - green_buffer[i]  )*k/n;
               dkgreen_buffer[i+k] = dkgreen_buffer[i]+ (dkgreen_buffer[i+n]- dkgreen_buffer[i])*k/n;
               red_buffer[i+k]     = red_buffer[i]    + (red_buffer[i+n]    - red_buffer[i]    )*k/n;
               maroon_buffer[i+k]  = maroon_buffer[i] + (maroon_buffer[i+n] - maroon_buffer[i] )*k/n;
            }
            else
            {
               if (green_buffer[i]  !=0) green_buffer[i+k]   = macd[i+k];
               if (dkgreen_buffer[i]!=0) dkgreen_buffer[i+k] = macd[i+k];
               if (red_buffer[i]    !=0) red_buffer[i+k]     = macd[i+k];
               if (maroon_buffer[i] !=0) maroon_buffer[i+k]  = macd[i+k];
            }               
         }             
   }
   
   //
   //
   //
   //
   //
   
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//
              
double stored[][14];
#define E1  0
#define E2  1
#define E3  2
#define E4  3
#define E5  4
#define E6  5
#define res 6

//
//
//
//
//

double iSmooth(double price, double averagePeriod, double tconst, bool adaptive, int i, int ashift=0)
{
   if (ArrayRange(stored,0) != Bars) ArrayResize(stored,Bars);
   if (averagePeriod <=1) return(price);
   int r = Bars-i-1; 
   
   double e1=stored[r-1][E1+ashift];  double e2=stored[r-1][E2+ashift];
   double e3=stored[r-1][E3+ashift];  double e4=stored[r-1][E4+ashift];
   double e5=stored[r-1][E5+ashift];  double e6=stored[r-1][E6+ashift];

   //
   //
   //
   //
   //

      if (adaptive && (averagePeriod > 1))
      {
         double minPeriod = averagePeriod/2.0;
         double maxPeriod = minPeriod*5.0;
         int    endPeriod = MathCeil(maxPeriod);
         double signal    = MathAbs((price-stored[r-endPeriod][res+ashift]));
         double noise     = 0.00000000001;

            for(int k=1; k<endPeriod; k++) noise=noise+MathAbs(price-stored[r-k][res+ashift]);

         averagePeriod = ((signal/noise)*(maxPeriod-minPeriod))+minPeriod;
      }
      
      //
      //
      //
      //
      //
      
      double alpha = (2.0+tconst)/(1.0+tconst+averagePeriod);

      e1 = e1 + alpha*(price-e1); e2 = e2 + alpha*(e1-e2); double v1 = 1.5 * e1 - 0.5 * e2;
      e3 = e3 + alpha*(v1   -e3); e4 = e4 + alpha*(e3-e4); double v2 = 1.5 * e3 - 0.5 * e4;
      e5 = e5 + alpha*(v2   -e5); e6 = e6 + alpha*(e5-e6); double v3 = 1.5 * e5 - 0.5 * e6;

   //
   //
   //
   //
   //

   stored[r][E1+ashift]  = e1;  stored[r][E2+ashift] = e2;
   stored[r][E3+ashift]  = e3;  stored[r][E4+ashift] = e4;
   stored[r][E5+ashift]  = e5;  stored[r][E6+ashift] = e6;
   stored[r][res+ashift] = price;
   return(v3);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}